#lang racket/base

(require racket/function
         (for-syntax racket/base)
         tests/eli-tester)

(provide @ curry define-curry curry-lambda)        

(define-syntax-rule
  (curry-lambda args body ...)
  (curry (lambda args body ...)))

(define-syntax-rule (define-curry (name args ...) body ...)
  (define name (curry-lambda (args ...) body ...)))

;; application of a curried function
(define-syntax (@ stx)
  (syntax-case stx ()
    [(_ curried arg) #'(curried arg)]
    [(_ curried arg1 arg ...)
     #'(@ (curried arg1) arg ...)]))

(test
 (@ (curry (lambda (x) x)) 5) => 5
 (@ (lambda (x) x) 5) => 5
 (@ (curry (lambda (a b) (+ a b))) 1 2) => 3
 (@ (curry (lambda (a b) (lambda (z) (+ a b z)))) 1 2 3) => 6)