module CCALib where

import Prelude hiding (init)
import StreamTransformer

assoc :: ((a, b), c) -> (a, (b, c))
assoc = \z -> (fst (fst z), (snd (fst z), snd z))

assoc_inv :: (a, (b, c)) -> ((a, b), c)
assoc_inv = \z -> ((fst z, fst (snd z)), snd (snd z)) 

juggle :: ((a, b), c) -> ((a, c), b)
juggle = assoc_inv . (id `times` swap) . assoc

transpose :: ((a, b), (c, d)) -> ((a, c), (b, d))
transpose = assoc . (juggle `times` id) . assoc_inv

shuffle :: (a, ((b, c), (d, e))) -> ((a, (b, d)), (c, e))
shuffle = assoc_inv . (id `times` transpose)

shuffle_inv :: ((a, (b, d)), (c, e)) -> (a, ((b, c), (d, e)))
shuffle_inv = (id `times` transpose) . assoc

times :: (a -> b) -> (c -> d) -> ((a, c) -> (b, d))
times = \f -> \g -> \z -> (f (fst z), g (snd z)) 

dup :: a -> (a, a)
dup = \x -> (x, x)

swap :: (a, b) -> (b, a)
swap = \z -> (snd z, fst z)

second :: SF b c -> SF (d, b) (d, c)
second = \f -> arr swap >>> first f >>> arr swap

loopB :: t -> SF (a, (g, t)) (b, (g, t)) -> SF a b
loopB = \i -> \f -> loop (f >>> second (second (init i)))
