#lang racket

(require "typing-rules.rkt"
         (prefix-in prototype: "define-judgment-form/define-judgment-form.rkt")
         "examples.rkt"
         rackunit)

(define-syntax-rule (choose variable judgment)
  (let ([sol-map (prototype:generate judgment +inf.0)])
    (and sol-map
         (second (assoc 'variable sol-map)))))

(check-equal? (choose τ (typeof • (unit) (? τ)))
              'unit)
(check-equal? (choose τ (typeof ((-> unit unit) (unit •)) (var (s z)) (? τ)))
              'unit)
(check-not-false (prototype:generate (typeof • (λ (var z)) (-> unit unit)) +inf.0))
(check-equal? (choose x (typeof ((pair unit unit) (unit •)) (var (? x)) unit))
              '(s z))

(check-equal? (prototype:generate (typeof ((-> unit unit) (unit •))
                                          (var z)
                                          unit)
                                  +inf.0)
              #f)
(check-equal? (prototype:generate (typeof ((-> unit unit) (unit •))
                                          (var (? x))
                                          (pair unit unit))
                                  +inf.0)
              #f)

(check-equal?
 (choose τ (typeof • 
                   ,(to-type-form integral)
                   (? τ)))
 '(arr num num))
(check-not-false
 (prototype:generate (typeof • ,(to-type-form fixA) (-> (arr num num) (arr unit num))) +inf.0))
(check-not-false
 (prototype:generate (typeof • ,(to-type-form exp) (arr unit num)) +inf.0))
(check-not-false
 (prototype:generate
  (typeof •
          ,(to-type-form loopB)
          (-> num
              (-> (arr (pair unit (pair (pair num num) num))
                       (pair (pair unit unit) (pair (pair num num) num)))
                  (arr unit (pair unit unit)))))
  +inf.0))