#lang racket
(require redex (for-syntax racket/base))

(provide set-of ∪ lfp clean-set ∪x ∈ ∈x)

(define-syntaxes (∈ ∈x) (values #f #f))

(define-syntax (set-of stx)
  (syntax-case stx (∈ ∈x)
    [(_ lang body pat ∈ exp . more)
     #`(apply append
              ((term-match lang 
                           (... [(any_this-should-be-hygenic-but-it-isnt ...
                                  pat 
                                  any_this-should-be-hygenic-but-it-isnt2 ...)
                                 (set-of lang body . more)]))
               (term exp)))]
    [(_ lang body (pat ...) ∈x exp . more)
     (with-syntax ([(any_this-should-be-hygenic-but-it-isnt ...)
                    (for/list ([pat (in-list (syntax->list #'(pat ...)))]
                               [i (in-naturals)])
                      (string->symbol (format "any_this-should-be-hygenic-but-it-isnt-~a" i)))]
                   [(any_this-should-be-hygenic-but-it-isnt2 ...)
                    (for/list ([pat (in-list (syntax->list #'(pat ...)))]
                               [i (in-naturals)])
                      (string->symbol (format "any_this-should-be-hygenic-but-it-isnt2-~a" i)))])
       #`(apply
          append
          ((term-match lang 
                       [((any_this-should-be-hygenic-but-it-isnt 
                          (... ...)
                          pat 
                          any_this-should-be-hygenic-but-it-isnt2
                          (... ...))
                         ...)
                        (set-of lang body . more)])
           (term exp))))]
    [(_ lang body)
     #`(list (term body))]))

(define (∪ . lloe) (clean-set (apply append lloe)))

(define (∪x arg1 . args)
  (define all-args (cons arg1 args))
  (define lens (map length all-args))
  (unless (or (null? args)
              (apply = lens))
    (error '∪x "expected all arguments to have the same length, got these lengths ~a for these values ~a"
           lens
           (apply
            string-append
            (map (λ (x) (format "\n  ~s" x))
                 all-args))))
  (map clean-set (apply map append all-args)))

(define (lfp f bot)
  (let loop ([this bot])
    (let ([next (f this)])
      (if (equal? this next)
          next
          (loop next)))))

(define (clean-set lst)
  (sort (remove-duplicates lst) string<=? #:key (λ (x) (format "~s" x))))
