#lang racket/base
(require redex
         tests/eli-tester
         "atotcaia-search.rkt")

(define p337-Σ 
  (term ((· lazy : (forall (a) ((Unit → a) → (Lazy a))))
         force : (forall (a) ((Lazy a) → a)))))

(define p337-ex
  (term
   (coerce (,p337-Σ
            ((· + : (Int → (Int → Int)))
             one : Int)
            ⊢ q q 
            ((λ y : (Lazy Int) ((+ y) one)) (λ x : Unit e))
            ~~>
            ((λ y : (Lazy Int) ((+ ((inst force (Int)) y)) one)) (lazy (λ x : Unit e)))
            :
            Int))))

; revision of the p337 example to 
;  - add in two ID coercions (one for each use of CPQ-PrimTrans)
;  - add 'e' to the environment
;  - add the type parameter to the lazy coercion
(define p337-ex2
  (term
   (coerce (,p337-Σ
            (((· + : (Int → (Int → Int)))
              one : Int)
             e : Int)
            ⊢ q q 
            ((λ y : (Lazy Int) ((+ y) one)) (λ x : Unit e))
            ~~>
            ((λ y : (Lazy Int) ((+ (((id Int) ◦ (inst force (Int))) y)) one)) 
             (((id (Lazy Int)) ◦ (inst lazy (Int))) (λ x : Unit e)))
            :
            Int))))

(define p337-function-position
  (term
   (coerce (,p337-Σ
            ((· + : (Int → (Int → Int)))
             one : Int)
            ⊢ q q 
            (λ y : (Lazy Int) ((+ y) one))
            ~~>
            (λ y : (Lazy Int) ((+ (((id Int) ◦ (inst force (Int))) y)) one))
            :
            ((Lazy Int) → Int)))))

(define p337-argument-position
  (term
   (coerce (,p337-Σ
            (· e : Int)
            ⊢ q q 
            (⟨ (Lazy Int) ⟩ (λ x : Unit e))
            ~~>
            (((id (Lazy Int)) ◦ (inst lazy (Int))) (λ x : Unit e))
            :
            (Lazy Int)))))

(test (true? p337-ex) => #f
      (true? p337-function-position)
      (true? p337-argument-position)
      (true? p337-ex2))
